## ros-kinetic-joint-trajectory-controller 0.13.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(joint_trajectory_controller)

# Load catkin and all dependencies required for this package
find_package(catkin
  REQUIRED COMPONENTS
    actionlib
    angles
    cmake_modules
    roscpp
    urdf
    control_toolbox
    controller_interface
    hardware_interface
    realtime_tools
    control_msgs
    trajectory_msgs
)

# Declare catkin package
catkin_package(
  CATKIN_DEPENDS
  actionlib
  angles
  roscpp
  urdf
  control_toolbox
  controller_interface
  hardware_interface
  realtime_tools
  control_msgs
  trajectory_msgs
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
)

include_directories(include ${Boost_INCLUDE_DIR} ${catkin_INCLUDE_DIRS})

add_library(${PROJECT_NAME} src/joint_trajectory_controller.cpp
                            include/joint_trajectory_controller/hardware_interface_adapter.h
                            include/joint_trajectory_controller/init_joint_trajectory.h
                            include/joint_trajectory_controller/joint_trajectory_controller.h
                            include/joint_trajectory_controller/joint_trajectory_controller_impl.h
                            include/joint_trajectory_controller/joint_trajectory_msg_utils.h
                            include/joint_trajectory_controller/joint_trajectory_segment.h
                            include/joint_trajectory_controller/tolerances.h
                            include/trajectory_interface/trajectory_interface.h
                            include/trajectory_interface/quintic_spline_segment.h
                            include/trajectory_interface/pos_vel_acc_state.h)

target_link_libraries(${PROJECT_NAME} ${catkin_LIBRARIES})

if(CATKIN_ENABLE_TESTING)
  find_package(catkin
    REQUIRED COMPONENTS
      actionlib
      controller_manager
      xacro
  )

  find_package(rostest REQUIRED)
  include_directories(include ${catkin_INCLUDE_DIRS})

  catkin_add_gtest(quintic_spline_segment_test test/quintic_spline_segment_test.cpp)
  target_link_libraries(quintic_spline_segment_test ${catkin_LIBRARIES})

  catkin_add_gtest(trajectory_interface_test test/trajectory_interface_test.cpp)
  target_link_libraries(trajectory_interface_test ${catkin_LIBRARIES})

  catkin_add_gtest(joint_trajectory_segment_test test/joint_trajectory_segment_test.cpp)
  target_link_libraries(joint_trajectory_segment_test ${catkin_LIBRARIES})

  catkin_add_gtest(joint_trajectory_msg_utils_test test/joint_trajectory_msg_utils_test.cpp)
  target_link_libraries(joint_trajectory_msg_utils_test ${catkin_LIBRARIES})

  catkin_add_gtest(init_joint_trajectory_test test/init_joint_trajectory_test.cpp)
  target_link_libraries(init_joint_trajectory_test ${catkin_LIBRARIES})

  add_rostest_gtest(tolerances_test
                  test/tolerances.test
                  test/tolerances_test.cpp)
  target_link_libraries(tolerances_test ${catkin_LIBRARIES})

  add_executable(rrbot test/rrbot.cpp)
  target_link_libraries(rrbot ${catkin_LIBRARIES})

  add_executable(rrbot_wrapping test/rrbot_wrapping.cpp)
  target_link_libraries(rrbot_wrapping ${catkin_LIBRARIES})

  add_dependencies(tests rrbot)
  add_dependencies(tests rrbot_wrapping)
  add_dependencies(tests ${PROJECT_NAME})

  add_rostest_gtest(joint_trajectory_controller_test
                    test/joint_trajectory_controller.test
                    test/joint_trajectory_controller_test.cpp)
  target_link_libraries(joint_trajectory_controller_test ${catkin_LIBRARIES})

  add_rostest_gtest(joint_trajectory_controller_stopramp_test
                    test/joint_trajectory_controller_stopramp.test
                    test/joint_trajectory_controller_test.cpp)
  target_link_libraries(joint_trajectory_controller_stopramp_test ${catkin_LIBRARIES})

  add_rostest_gtest(joint_trajectory_controller_vel_test
                    test/joint_trajectory_controller_vel.test
                    test/joint_trajectory_controller_test.cpp)
  target_link_libraries(joint_trajectory_controller_vel_test ${catkin_LIBRARIES})
  target_compile_definitions(joint_trajectory_controller_vel_test PRIVATE TEST_VELOCITY_FF=1)

  add_rostest_gtest(joint_trajectory_controller_wrapping_test
                    test/joint_trajectory_controller_wrapping.test
                    test/joint_trajectory_controller_wrapping_test.cpp)
  target_link_libraries(joint_trajectory_controller_wrapping_test ${catkin_LIBRARIES})

endif()

# Install
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

install(DIRECTORY include/trajectory_interface/
  DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}/trajectory_interface/)

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  )

install(FILES ros_control_plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

# TODO: Install test resource files as well?

=== debian/changelog ===
ros-kinetic-joint-trajectory-controller (0.13.6-1xenial) xenial; urgency=high

  * Cherry pick nullptr fix
    * correctly parse joint trajectory options
    * Backport nullptr check
  * Print error messages for all exceptions
  * Contributors: Bence Magyar, Karsten Knese, Ian Frosst

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sun, 12 Jan 2020 00:00:00 -0000

ros-kinetic-joint-trajectory-controller (0.13.5-1xenial) xenial; urgency=high

  * Report errors in updateTrajectoryCommand back though action result error_string
  * Remove redundant warning messages
  * Return error string when failing to initialize trajectory from message
  * don't print warning about dropped first point (#366 <https://github.com/ros-controls/ros_controllers/issues/366>)
  * Contributors: Mathias Lüdtke, Miguel Prada, hsl, jschleicher

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sat, 09 Feb 2019 00:00:00 -0000

ros-kinetic-joint-trajectory-controller (0.13.4-1xenial) xenial; urgency=high

  * joint_trajectory_controller improve test stability
  * Use a copy of rt_active_goal in update()
  * Changes to allow inheritance from JointTrajectoryController.
  * Contributors: Alexander Gutenkunst, Gennaro Raiola, Kei Okada, Ryosuke Tajima

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Mon, 25 Jun 2018 23:00:00 -0000

ros-kinetic-joint-trajectory-controller (0.13.3-1xenial) xenial; urgency=high

  * migrate to new pluginlib headers
  * TrajectoryController: Use desired state to calculate hold trajectory (#297 <https://github.com/ros-controls/ros_controllers/issues/297>)
  * Add velocity feedforward term to velocity HardwareInterfaceAdapter (#227 <https://github.com/ros-controls/ros_controllers/issues/227>)
  * Contributors: Mathias Lüdtke, Miguel Prada, agutenkunst

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Thu, 26 Apr 2018 23:00:00 -0000

ros-kinetic-joint-trajectory-controller (0.13.2-1xenial) xenial; urgency=high

  * Changend the implementation of joint_trajectory_controller to enable the forwarding of the acceleration values from the trajectory
  * Contributors: Bence Magyar, Mart Moerdijk

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sat, 23 Dec 2017 00:00:00 -0000

ros-kinetic-joint-trajectory-controller (0.13.1-1xenial) xenial; urgency=high

  * Linted pos_vel joint_trajectory_controllers
  * Added posvel joint_trajectory_controller
    Added a simple posvel joint_trajectory_controller that forwards
    the desired state at the current point in time of the trajectory
    to the joint.
  * Add support for an joint interfaces are not inherited from JointHandle.
    Add JointTrajectoryController specification for SplineJointInterface.
  * Contributors: Gennaro Raiola, Igorec, Zach Anderson

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Mon, 06 Nov 2017 00:00:00 -0000

ros-kinetic-joint-trajectory-controller (0.13.0-1xenial) xenial; urgency=high

  * Make rqt_plot optional
  * Added tests for issue #275 <https://github.com/ros-controls/ros_controllers/issues/275>
  * Address Issue  #275 <https://github.com/ros-controls/ros_controllers/issues/275> for kinetic
  * Address issue #263 <https://github.com/ros-controls/ros_controllers/issues/263>, joint_trajectory_controller - wraparoundOffset
  * Added warning to indicate that the verbose flag is enabled
  * Set hold trajectory goal handle when empty trajectory received through action.
    Previously, an empty trajectory received through the action interface would
    set hold trajectory and accept the action goal, but the action would never be
    terminated, leaving clients hanging.
  * Contributors: Bence Magyar, Miguel Prada, bponsler, gennaro

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Wed, 09 Aug 2017 23:00:00 -0000

ros-kinetic-joint-trajectory-controller (0.12.3-1xenial) xenial; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sat, 22 Apr 2017 23:00:00 -0000

ros-kinetic-joint-trajectory-controller (0.12.2-1xenial) xenial; urgency=high

  * Remove rqt_plot test_depend & make plots optional
  * Contributors: Bence Magyar

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Thu, 20 Apr 2017 23:00:00 -0000

ros-kinetic-joint-trajectory-controller (0.12.1-1xenial) xenial; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Wed, 08 Mar 2017 00:00:00 -0000

ros-kinetic-joint-trajectory-controller (0.12.0-1xenial) xenial; urgency=high

  * Fix missing controller_manager include
  * Ordered dependencies & cleanup
  * Change for format2
  * Add Enrique and Bence to maintainers
  * Add test that sends trajectory entirely in past
  * Use xacro instead of xacro.py
  * urdf::Model typedefs had to be added to a different repo first
  * Updated copyright info
  * jtc: Enable sending trajectories with a partial set of joints
  * Replace boost::shared_ptr<urdf::XY> with urdf::XYConstSharedPtr when exists
  * Infrastructure for testing the velocity_controllers::JointTrajectoryController.
  * jtc: Enable sending trajectories with a partial set of joints
  * Contributors: Beatriz Leon, Bence Magyar, Miguel Prada

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Wed, 15 Feb 2017 00:00:00 -0000

ros-kinetic-joint-trajectory-controller (0.11.2-1xenial) xenial; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Mon, 15 Aug 2016 23:00:00 -0000

ros-kinetic-joint-trajectory-controller (0.11.1-1xenial) xenial; urgency=high

  * Write feedback for the RealtimeServerGoalHandle to publish on the non-realtime thread.
  * Contributors: Miguel Prada

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sun, 22 May 2016 23:00:00 -0000



=== debian/control ===
Source: ros-kinetic-joint-trajectory-controller
Section: misc
Priority: optional
Maintainer: Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>
Build-Depends: debhelper (>= 9.0.0), ros-kinetic-actionlib, ros-kinetic-angles, ros-kinetic-catkin, ros-kinetic-cmake-modules, ros-kinetic-control-msgs, ros-kinetic-control-toolbox, ros-kinetic-controller-interface, ros-kinetic-controller-manager, ros-kinetic-hardware-interface, ros-kinetic-realtime-tools, ros-kinetic-roscpp, ros-kinetic-rostest, ros-kinetic-trajectory-msgs, ros-kinetic-urdf, ros-kinetic-xacro
Homepage: https://github.com/ros-controls/ros_controllers/wiki
Standards-Version: 3.9.2

Package: ros-kinetic-joint-trajectory-controller
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-kinetic-actionlib, ros-kinetic-angles, ros-kinetic-control-msgs, ros-kinetic-control-toolbox, ros-kinetic-controller-interface, ros-kinetic-hardware-interface, ros-kinetic-realtime-tools, ros-kinetic-roscpp, ros-kinetic-trajectory-msgs, ros-kinetic-urdf
Description: Controller for executing joint-space trajectories on a group of joints.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-joint-trajectory-controller//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
